﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls;
using Telerik.WinControls.UI;

namespace _774013
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            ProgressBarColumn col1 = new ProgressBarColumn("Test");
            GridViewTextBoxColumn col2 = new GridViewTextBoxColumn();
            GridViewCheckBoxColumn col3 = new GridViewCheckBoxColumn();
            GridViewTextBoxColumn col4 = new GridViewTextBoxColumn();
    

            radGridView1.Columns.Add(col1);
            radGridView1.Columns.Add(col2);
            radGridView1.Columns.Add(col3);
            radGridView1.Columns.Add(col4);

            for (int i = 0; i < 10; i++)
            {
                radGridView1.Rows.Add(20, "Row " + i, true);
            }
            radGridView1.TableElement.RowHeight = 40;
            radGridView1.CellClick += radGridView1_CellClick;
        }

        void radGridView1_CellClick(object sender, GridViewCellEventArgs e)
        {
            if (e.Column is ProgressBarColumn && e.RowIndex >1)
            {
                RadMessageBox.Show("ProgressBar Clicked");
            }
        }

    }

    public class ProgressBarCellElement : GridDataCellElement
    {
        public ProgressBarCellElement(GridViewColumn column, GridRowElement row) : base(column, row)
        {
        }

        private RadProgressBarElement radProgressBarElement;

        protected override void CreateChildElements()
        {
            base.CreateChildElements();

            radProgressBarElement = new RadProgressBarElement();
            radProgressBarElement.Click += radProgressBarElement_Click;
            this.Children.Add(radProgressBarElement);
        }

        void radProgressBarElement_Click(object sender, EventArgs e)
        {
            if (this.RowIndex == 1)
            {
                RadMessageBox.Show("Row 2 clicked");
            }
        }

        protected override void SetContentCore(object value)
        {
            if (this.Value != null && this.Value != DBNull.Value)
            {
                this.radProgressBarElement.Value1 = Convert.ToInt32(this.Value);
            }
        }

        protected override Type ThemeEffectiveType
        {
            get
            {
                return typeof(GridDataCellElement);
            }
        }

        public override bool IsCompatible(GridViewColumn data, object context)
        {
            return data is ProgressBarColumn && context is GridDataRowElement;
        }
    }

    public class ProgressBarColumn : GridViewDataColumn
    {
        public ProgressBarColumn(string fieldName) : base(fieldName)
        {
        }

        public override Type GetCellType(GridViewRowInfo row)
        {
            if (row is GridViewDataRowInfo)
            {
                return typeof(ProgressBarCellElement);
            }
            return base.GetCellType(row);
        }
    }
}